/*
 * Copyright (C) 1997 Wolfgang Moser
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * This is an enhanced class derived from TPathAVLtree with
 * an added print-method. So you can see the traversion order
 * and statistic informations.
 */

#ifndef _EnhanceTree_Long_
#define _EnhanceTree_Long_

#include <iostream.h>
#include <iomanip.h>
#include "tpavltre.h"
#include "nodelong.h"

class EnhTreeLong:public TPathAVLtree<simpleNodeLong, 64>{
   public:
      EnhTreeLong(void);
      ~EnhTreeLong(void);

      inline void print    (void);
   private:
      static long i,maxNUL,minNUL;

      inline void print    (simpleNodeLong *);
   };

inline EnhTreeLong::EnhTreeLong(void){
   }

inline EnhTreeLong::~EnhTreeLong(void){
   }

inline void EnhTreeLong::print(void){
   i=0,maxNUL=0,minNUL=(((unsigned long)(-1))>>1);
   print(NULL);
   }

inline void EnhTreeLong::print(simpleNodeLong *p){
   if(p!=NULL){
      i++;
#if defined(__BORLANDC__) || defined(__WATCOMC__)
      cout << " \xD9" << flush;
      print((simpleNodeLong *)p->getNode(PathAVLnode::LEFT));
      cout << " \xDA\n"
           << setw(6)      << p->get()
           << setw(1+24-i) << setfill('\xFA') << ' '
           << ((p->getBal())<0
               ? ((p->getBal())==-1?'-':'!')
               : ((p->getBal())    ?'+':'\xFE'))
           << setw(2+   i) << setfill(' ')
           << " \xC0" << flush;
      print((simpleNodeLong *)p->getNode(PathAVLnode::RIGHT));
      cout << " \xBF" << flush;
#else
      cout << " ul" << flush;
      print((simpleNodeLong *)p->getNode(PathAVLnode::LEFT));
      cout << " or\n"
           << setw(8)      << p->get()
           << setw(1+24-i) << setfill('\xB7') << " "
           << ((p->getBal())<0
               ? ((p->getBal())==-1?'-':'!')
               : ((p->getBal())    ?'+':'o'))
           << setw(3+   i) << setfill(' ')
           << " ur" << flush;
      print((simpleNodeLong *)p->getNode(PathAVLnode::RIGHT));
      cout << " ol" << flush;
#endif
      i--;
      }
   else{
      if(i==0){
         i++;
         maxNUL=0;
         minNUL=(((unsigned long)(-1))>>1);

#if defined(__BORLANDC__) || defined(__WATCOMC__)
         cout << "\nbegin:                          " << flush;
#else
         cout << "\nbegin:                            " << flush;
#endif
         print((simpleNodeLong *&)Wurzel);
         cout << "\nend\n\nminNUL=" << minNUL
              << " maxNUL=" << maxNUL << endl;
         i--;
         }
      else{
#if defined(__BORLANDC__)
         cout << " \xED" << flush;
#elif defined(__WATCOMC__)
         cout << " \x9E" << flush;
#else
         cout << " \xA4" << flush;
#endif
         if(i>maxNUL) maxNUL=i;
         if(i<minNUL) minNUL=i;
         }
      }
   }

#endif

